function SearchSubmissionsByDemogRequest () {
	this.version="";
	this.lang="";
	this.bpId="";
	this.firstName="";
	this.lastName="";
	this.companyName="";
	this.phoneNumber="";
	this.email="";
	this.address="";
	this.address2="";
	this.zipCode="";
	this.city="";    
	this.state="";
    this.submissionStatus=null,    
	this.resultSize="100";
	this.pageNumber="1";
	this.allowWildcardSearch="false";    
	this.insertDateFrom="";     
	this.insertDateTo="";
}



function PaginatedSubmissionsByCampAttrRequest () {
		var modalreq = {
            "lang": "en_US",
            "version": "1",
            "resultSize": "100",
            "businessPartnerId": "23857",
            "fromDate": "",
            "toDate": "",
            "submissionStatus":null,
            "searchCriteria": [
                {
                    "masterAttributeId": "10356",
                    "masterAttributeName": null,
                    "attributeValue": "VERIZON"
                },
                {
                    "masterAttributeId": "8396",
                    "masterAttributeName": null,
                    "attributeValue": "false"
                }
            ]
        };
        
        return modalreq;
}

function getSeachSubmissionsByDemogRequest() {
    var request= new SearchSubmissionsByDemogRequest();
    request.lang=SETTINGS.DEFAULT_LANG;
    request.version=SETTINGS.DEFAULT_VERSION;  
    request.bpId="23857";   
    request.firstName=jQuery('#demogFirstName').val();   
    request.lastName=jQuery('#demogLastName').val();   
    request.phoneNumber=jQuery('#demogPhoneNumber').val();   
    request.email=jQuery('#demogEmail').val();   
    request.address=jQuery('#demogAddress').val();   
    request.address2=jQuery('#demogAddress2').val();      
    request.zipCode=jQuery('#demogZipCode').val();   
    if(jQuery('#demogSubmissionStatus').val() !=  "")
        request.submissionStatus=[jQuery('#demogSubmissionStatus').val()]; 

    if( jQuery('input:radio[name=searchfilter]:checked').val() == 'daysFilter' ) {

        var nDays = jQuery('#days_select').val();
        
        if(nDays != "") {
            
                //To Date
            var today = new Date();
            var dd = today.getDate();
            var mm = today.getMonth()+1; //January is 0!

            var yyyy = today.getFullYear();
            if(dd<10){dd='0'+dd} if(mm<10){mm='0'+mm} today = mm+'-'+dd+'-'+yyyy;

            //From Date
            var fromDate = new Date();
            var temp = fromDate.getTime() - 1000*60*60*24*parseInt(nDays); // Offset by one day;
            fromDate.setTime( temp );

            dd = fromDate.getDate();
            mm = fromDate.getMonth()+1; //January is 0!

            yyyy = fromDate.getFullYear();
            if(dd<10){dd='0'+dd} if(mm<10){mm='0'+mm} fromDate = mm+'-'+dd+'-'+yyyy;
            
            request.insertDateFrom = fromDate;
            request.insertDateTo = today;        
            
        }    
    
    }else if( jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ) {
        request.insertDateFrom = jQuery('#from_dateSelect').val().split("/").join("-");
        request.insertDateTo = jQuery('#to_dateSelect').val().split("/").join("-");
    }
    
    var bconfirmation = confirmDemogSearch();
    if(!bconfirmation) {
       return false;
    }    
        
    return JSON.stringify(request);

}

function  getPaginatedSubmissionsByCampAttrRequest() {
    var request= new PaginatedSubmissionsByCampAttrRequest();

    var bconfirmation = confirmCampAttrSearch();
    if(!bconfirmation) {
       return false;
    }
    
    //To Date
    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth()+1; //January is 0!

    var yyyy = today.getFullYear();
    if(dd<10){dd='0'+dd} if(mm<10){mm='0'+mm} today = mm+'-'+dd+'-'+yyyy;

    //From Date
    var fromDate = new Date();
    var temp = fromDate.getTime() - 1000*60*60*24*10; // Offset by one day;
    fromDate.setTime( temp );

    dd = fromDate.getDate();
    mm = fromDate.getMonth()+1; //January is 0!

    yyyy = fromDate.getFullYear();
    if(dd<10){dd='0'+dd} if(mm<10){mm='0'+mm} fromDate = mm+'-'+dd+'-'+yyyy;

    var count = 0;
    
    if( jQuery('input:radio[name=searchfilter]:checked').val() == 'daysFilter' ) {
        request.fromDate=fromDate;
        request.toDate=today;
    }else if( jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ) {
        request.fromDate = jQuery('#from_dateSelect').val().split("/").join("-");
        request.toDate = jQuery('#to_dateSelect').val().split("/").join("-");
    }

    jQuery("#SearchByCampAttribData input, #SearchByCampAttribData select").each(function(){
       if($.trim($(this).val()).length > 0)
       {
         if($(this).attr("id") == 'campAttrSubmissionStatus') {
             request.submissionStatus = [$(this).val()];
         } else {
             request.searchCriteria[count].masterAttributeId = $(this).attr("masterAttrId");
             request.searchCriteria[count].attributeValue = $(this).val();
             count++;
         }
       }

    });
    
    if(count == 1) {
        request.searchCriteria.splice(1,1);
    }
    return JSON.stringify(request);;
}

function openSearchTab(tabId) {
    $("#SearchtabMenu dd").each(function(){
        $(this).removeClass( "active" ); // This is the jquery object of the input, do what you will
        jQuery( eval($(this)[0].id  + 'Data')).hide();
        
        if( $(this)[0].id == tabId) {
            seletedSearchTabId=tabId;
            jQuery(eval($(this)[0].id  + 'Data')).show();
            $(this).addClass( "active");

        }
    });
}

function validatorSeachByMTNSubmForm() {
    $('#formSearchSubm').removeData('validator');
    return jQuery("#formSearchSubm").validate({
        onfocusout:false,
        onkeyup:false,
        errorClass:'error',        
        rules: {
            vzwTrackingNo: { 
                required: false,
                validTrackingNo: true
            },
            mtn: {
                required: function(element){
                    return jQuery("#vzwTrackingNo").val().length <= 0;
                },
                validMTN: true
            },
            from_dateSelect: {
                required: function(element){
                    return jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ;
                },
                validFilterDate: true
        
            },
            to_dateSelect: {
                required: function(element){
                    return jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ;
                },
                validFilterDate: true,
                validFilterDateRange: true
            }
        },
        messages: {
            vzwTrackingNo: { 
                required: MESSAGES.ERROR.TRACKING_NO_REQUIRED,
                validTrackingNo: MESSAGES.ERROR.TRACKING_NO_INVALID
            },
            mtn: {
                required: "Verizon Tracking Number or MTN is required.",
                validMTN: MESSAGES.ERROR.MTN_INVALID
            },
            from_dateSelect: {
                required: MESSAGES.ERROR.FROM_DATE_REQUIRED,
                validFilterDate : MESSAGES.ERROR.FROM_DATE_INVALID
            },		
            to_dateSelect: {
                required: MESSAGES.ERROR.TO_DATE_REQUIRED,
                validFilterDate : MESSAGES.ERROR.TO_DATE_INVALID,
                validFilterDateRange: MESSAGES.ERROR.FILTER_DATE_RANGE_INVALID
            }
        }
    }).form();
}

function validatorSeachByDemogSubmForm() {
    $('#formSearchSubm').removeData('validator');
    
    jQuery('#demogLastName').val(jQuery.trim(jQuery('#demogLastName').val().toUpperCase()));
    jQuery('#demogFirstName').val(jQuery.trim(jQuery('#demogFirstName').val().toUpperCase()));
    jQuery('#demogAddress').val(jQuery.trim(jQuery('#demogAddress').val().toUpperCase()));
    jQuery('#demogAddress2').val(jQuery.trim(jQuery('#demogAddress2').val().toUpperCase()));    
    jQuery('#demogPhoneNumber').val(jQuery.trim(jQuery('#demogPhoneNumber').val().toUpperCase()));
    jQuery('#demogZipCode').val(jQuery.trim(jQuery('#demogZipCode').val()));
    jQuery('#demogEmail').val(jQuery.trim(jQuery('#demogEmail').val().toUpperCase()));

    var tab2validationRes= jQuery("#formSearchSubm").validate({
        onfocusout:false,
        onkeyup:false,
        errorClass:'error',
        rules: {
            demogLastName: { 
                maxlength: 50
            },
            demogFirstName: {
                maxlength: 50
            },
            demogAddress: {
                maxlength: 50
            },
            demogAddress2: {
                maxlength: 50
            },            
            demogPhoneNumber: {
                validPhoneNum: true
            },
            demogZipCode: {
                validZipcode5:true,
            },
            demogEmail: {
                maxlength: 100
            },
            from_dateSelect: {
                required: function(element){
                    return jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ;
                },
                validFilterDate: true
        
            },
            to_dateSelect: {
                required: function(element){
                    return jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ;
                },
                validFilterDate: true,
                validFilterDateRange: true
            }
        },
        errorPlacement: function(error, element) {
                if(element.attr("id") == 'from_dateSelect'  || element.attr("id") == 'to_dateSelect') {
                    error.insertAfter( element ); 
                } else {
                    error.insertAfter(element.parent()).addClass("offset-by-six"); 
                }
        },
        messages: {
            demogLastName: { 
                maxlength: MESSAGES.VALIDATION.DEMOG_LASTNAME_MAXLEN
            },
            demogFirstName: {
                maxlength: MESSAGES.VALIDATION.DEMOG_FIRSTNAME_MAXLEN
            },
            demogAddress: {
                maxlength : MESSAGES.VALIDATION.DEMOG_ADDRESS_MAXLEN
            },		
            demogAddress2: {
                maxlength : MESSAGES.VALIDATION.DEMOG_ADDRESS2_MAXLEN
            },            
            demogPhoneNumber: {
                validPhoneNum: MESSAGES.VALIDATION.DEMOG_PHONE_INVALID
            },
            demogZipCode: {
                validZipcode5 : MESSAGES.VALIDATION.DEMOG_ZIPCODE_INVALID
            },		
            demogEmail: {
                maxlength : MESSAGES.VALIDATION.DEMOG_EMAIL_MAXLEN
            },
            from_dateSelect: {
                required: MESSAGES.ERROR.FROM_DATE_REQUIRED,
                validFilterDate : MESSAGES.ERROR.FROM_DATE_INVALID
            },		
            to_dateSelect: {
                required: MESSAGES.ERROR.TO_DATE_REQUIRED,
                validFilterDate : MESSAGES.ERROR.TO_DATE_INVALID,
                validFilterDateRange: MESSAGES.ERROR.FILTER_DATE_RANGE_INVALID
            }
        }
    }).form();

    var count = 0;
    jQuery('#demogErrorMsg').html("");
    jQuery('#demogErrorMsg').show();
    
    jQuery("#SearchByDemogData input, #SearchByDemogData select").each(function(){
       if($.trim($(this).val()).length > 0)
       {
          count++;
       }
    });
    
    if(count == 0) {
       jQuery('#demogErrorMsg').html(MESSAGES.VALIDATION.DEMOG_SEARCH_FIELDS_EMPTY).addClass("error");
       tab2validationRes = false;
    } else if(jQuery('#demogLastName').val() == "" && jQuery('#demogAddress').val() == "" &&  
       jQuery('#demogPhoneNumber').val() == "" && jQuery('#demogEmail').val() == ""       ) {

       jQuery('#demogErrorMsg').html(MESSAGES.VALIDATION.DEMOG_PRIMARYFIELD_REQUIRED).addClass("error");
       tab2validationRes =  false;
    }
    
    
    return tab2validationRes;
}

function validatorSeachByCampAttrSubmForm() {
    $('#formSearchSubm').removeData('validator');
    
    jQuery('#campAttrLastName').val(jQuery.trim(jQuery('#campAttrLastName').val().toUpperCase()));
    jQuery('#campAttrFirstName').val(jQuery.trim(jQuery('#campAttrFirstName').val().toUpperCase()));
    jQuery('#campAttrPaystubCompName').val(jQuery.trim(jQuery('#campAttrPaystubCompName').val().toUpperCase()));
    jQuery('#campAttrPrevalidationEcpdId').val(jQuery.trim(jQuery('#campAttrPrevalidationEcpdId').val().toUpperCase()));
    jQuery('#campAttrPostvalidationEcpdId').val(jQuery.trim(jQuery('#campAttrPostvalidationEcpdId').val().toUpperCase()));

    var tab2validationRes= jQuery("#formSearchSubm").validate({
        onfocusout:false,
        onkeyup:false,
        errorClass:'error',
        rules: {
            campAttrLastName: { 
                maxlength: 50
            },
            campAttrFirstName: {
                maxlength: 50
            },
            campAttrPaystubCompName: {
                maxlength: 50
            },
            campAttrPrevalidationEcpdId: {
                validEcpdId: true,
                maxlength: 9
            },
            campAttrPostvalidationEcpdId: {
                validEcpdId: true,            
                maxlength: 9
            },
            from_dateSelect: {
                required: function(element){
                    return jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ;
                },
                validFilterDate: true
        
            },
            to_dateSelect: {
                required: function(element){
                    return jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ;
                },
                validFilterDate: true,
                validFilterDateRange: true
            }            
        },
        errorPlacement: function(error, element) {
            if(element.attr("id") == 'from_dateSelect'  || element.attr("id") == 'to_dateSelect') {
                error.insertAfter( element ); 
            } else {
                error.insertAfter(element.parent()).addClass("offset-by-six"); 
            }
        },
        messages: {
            campAttrLastName: { 
                maxlength: MESSAGES.VALIDATION.CAMPATTR_LASTNAME_MAXLEN
            },
            campAttrFirstName: {
                maxlength: MESSAGES.VALIDATION.CAMPATTR_FIRSTNAME_MAXLEN
            },
            campAttrPaystubCompName: {
                maxlength : MESSAGES.VALIDATION.CAMPATTR_COMPANY_NAME_MAXLEN
            },		
            campAttrPrevalidationEcpdId: {
                validEcpdId : MESSAGES.VALIDATION.CAMPATTR_ECPD_ID_INVALID,            
                maxlength : MESSAGES.VALIDATION.CAMPATTR_ECPD_ID_MAXLEN
            },
            campAttrPostvalidationEcpdId: {
                validEcpdId : MESSAGES.VALIDATION.CAMPATTR_ECPD_ID_INVALID,            
                maxlength : MESSAGES.VALIDATION.CAMPATTR_ECPD_ID_MAXLEN
            },
            from_dateSelect: {
                required: MESSAGES.ERROR.FROM_DATE_REQUIRED,
                validFilterDate : MESSAGES.ERROR.FROM_DATE_INVALID
            },		
            to_dateSelect: {
                required: MESSAGES.ERROR.TO_DATE_REQUIRED,
                validFilterDate : MESSAGES.ERROR.TO_DATE_INVALID,
                validFilterDateRange: MESSAGES.ERROR.FILTER_DATE_RANGE_INVALID
            }        
        }
    }).form();

    var count = 0;
    var isCampAttrSubStatusSelected = false;

    jQuery("#SearchByCampAttribData input, #SearchByCampAttribData select").each(function(){
       if($.trim($(this).val()).length > 0)
       {
            if($(this).attr("id") == 'campAttrSubmissionStatus') {
                //Do not count towards this towards the total number of campaign attributes
                isCampAttrSubStatusSelected=true;
            } else {
                count++;
            }

       }
    });

    jQuery('#campAttrErrorMsg').html("");
    jQuery('#campAttrErrorMsg').show();
    if(count == 0) {
        if(isCampAttrSubStatusSelected) {
            jQuery('#campAttrErrorMsg').html(MESSAGES.VALIDATION.CAMPATTR_SEARCH_FIELDS_EMPTY).addClass("error");          
        } else {
            jQuery('#campAttrErrorMsg').html(MESSAGES.VALIDATION.CAMPATTR_SEARCH_FIELDS_EMPTY).addClass("error");    
        }
       tab2validationRes = false;
    } else if(count > 2) {
        jQuery('#campAttrErrorMsg').html(MESSAGES.VALIDATION.CAMPATTR_MAX_SEARCH_FIELDS_EXCEEDED).addClass("error");
       tab2validationRes = false;
    } 
    
    return tab2validationRes;
}

function confirmDemogSearch() {

	try {
		var daysBetween = 0;
		if( jQuery('input:radio[name=searchfilter]:checked').val() == 'daysFilter' ) {
			daysBetween = jQuery('#days_select').val();
		}else if( jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ) {
			daysBetween = (new Date(jQuery('#to_dateSelect').val()) - new Date(jQuery('#from_dateSelect').val()) )/1000/60/60/24;
		}
		
		if(daysBetween === "" || parseInt(daysBetween) > 90 ) {
			// return confirm(MESSAGES.ERROR.SUBMISSION_SEARCH_DATE_RANGE_MORE_THAN_90_DAYS_OLD);
		}
	} catch(e) {
		console.log("Exception occured");
	}
	return true;
}

function confirmCampAttrSearch() {

	try {
		var daysBetween = 0;
		if( jQuery('input:radio[name=searchfilter]:checked').val() == 'daysFilter' ) {
			alert("Searching Account Information tab beyond last 10 days is not currently available.");
            return false;
		}else if( jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ) {
			daysBetween = (new Date(jQuery('#to_dateSelect').val()) - new Date(jQuery('#from_dateSelect').val()) )/1000/60/60/24;
		}
		
		if(daysBetween === "" || parseInt(daysBetween) > 10 ) {
			alert("Date range is more than 10 days. Please update the date range to reflect a 10 day range.");
            return false;
		}
	} catch(e) {
		console.log("Exception occured");
	}
	return true;
}

jQuery(document).ready(function() {

	jQuery.validator.addMethod("validFilterDate", function(value, element) {
        try { 
		    //If Date range radio button is not selected, do not validate the fields
			if(jQuery('input:radio[name=searchfilter]:checked').val() != 'dateRangeFilter') {
				return true;
			}
			jQuery.datepicker.parseDate( 'mm/dd/yy', value); 
			var minDate = new Date(SETTINGS.SUBMISSIONS_MIN_DATE); 
			var maxDate =  new Date();
			maxDate = new Date(maxDate.setDate(maxDate.getDate()+1));
			
			if (Date.parse(value) < minDate || Date.parse(value) > maxDate) {
				return false;
			}
	
			return true; 
		}
        catch(e){
			return false;
		}
			   
    }, MESSAGES.ERROR.FILTER_DATE_INVALID);
    
    
    jQuery.validator.addMethod("validFilterDateRange", function(value, element) {
        try { 
		    //If Date range radio button is not selected, do not validate the fields
			if(jQuery('input:radio[name=searchfilter]:checked').val() != 'dateRangeFilter') {
				return true;
			}
	
			if(jQuery("#from_dateSelect").validate().valid() && jQuery("#to_dateSelect").validate().valid()) {
		      if(new Date(jQuery('#to_dateSelect').val()) < new Date(jQuery('#from_dateSelect').val()) ) {
			     return false;
			  }
			}
			return true; 
		}
        catch(e){
			return false;
		}
			   
    }, MESSAGES.ERROR.FILTER_DATE_RANGE_INVALID);
    
    jQuery.validator.addMethod("hasPrimaryDemogField", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.MTN_REGEX.test(value);
    }, MESSAGES.ERROR.USERNAME_INVALID);

    jQuery.validator.addMethod("validMTN", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.MTN_REGEX.test(value);
    }, MESSAGES.ERROR.USERNAME_INVALID);
	
    jQuery.validator.addMethod("validTrackingNo", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.TRACKING_NO_REGEX.test(value);
    }, MESSAGES.ERROR.PASSWORD_INVALID);

    jQuery.validator.addMethod("validPhoneNum", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.MTN_REGEX.test(value);
    }, MESSAGES.VALIDATION.DEMOG_PHONE_INVALID);
    
    jQuery.validator.addMethod("validZipcode5", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.ZIPCODE5_REGEX.test(value);
    }, MESSAGES.VALIDATION.DEMOG_ZIPCODE_INVALID); 
    
    jQuery.validator.addMethod("validEcpdId", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.NUMBER_REGEX.test(value);
    }, MESSAGES.VALIDATION.DEMOG_ZIPCODE_INVALID);     
}); //jQuery(document).ready
