VALIDATIONS={
		REGEX: {
			USERNAME_REGEX : /^[a-zA-Z0-9._]+$/,
			PASSWORD_REGEX : /^(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])(?=.*[^a-zA-Z0-9])[A-Za-z0-9~`!@#$%^&*()_+={}\-]{8,50}$/,

			MTN_REGEX : /^\d{10}$/,
            ZIPCODE5_REGEX : /^\d{5}$/,
            NUMBER_REGEX : /^\d*$/,
			TRACKING_NO_REGEX : /^[a-zA-Z]\d{13}$/,
			ECPD_ID_REGEX : /^[0-9]{1,10}$/,

			VZW_EMAIL: /^[a-zA-Z0-9._\-]+@(verizonwireless|parago|bhengagement|verizon|one\.verizon).com$/

		},
        MASK: {
            PHONE_NUMBER_MASK:"(999)999-9999",
            MTN_MASK:"(999)999-9999",
            ZIP5_MASK:"99999"
		}
};

//URLS
URLS={
		WP_CONTENT: "/wp-content/themes/verizonTrack-foundation-master-child/",
		AUTHENTICATE_USER_REST_SERVICE_URL: "http://localhost:8080/rest/VzwCareService/AuthenticateUser",
		SEARCH_SUBMISSIONS_REST_SERVICE_URL: "http://localhost:8080/rest/VzwCareService/RetrieveSubmissions",
		SEARCH_SUBMISSIONS_BY_DEMOG_REST_SERVICE_URL: "http://localhost:8080/rest/VzwCareService/RetrieveSubmissionsByDemog",
		SEARCH_PAGINATED_SUBMISSIONS_BY_CAMPATTR_REST_SERVICE_URL: "http://localhost:8080/rest/VzwCareService/PagedSearchSubmissionsByCampaignAttiributes",
		RETRIEVE_ECPD_HISTORY_REST_SERVICE_URL:"http://localhost:8080/rest/VzwCareService/RetrieveEcpdProfileHistoryData",
		PAY_STUB_HAS_IMAGE_REST_SERVICE_URL:"http://localhost:8080/rest/VzwCareService/SubmissionHasFilesByTrackingNumber",
		PAY_STUB_GET_IMAGE_REST_SERVICE_URL:"http://localhost:8080/rest/VzwCareService/GetSubmissionFilesByTrackingNumber",
		GET_SUBMISSION_HISTORY_REST_SERVICE_URL:"http://localhost:8080/rest/VzwCareService/GetSubmissionHistoryByTrackingNumber",
        BFO_VALIDATE_SUBMISSION_REST_SERVICE_URL:"http://localhost:8080/rest/VzwCareService/UpdateSubmissionStatus",
		AUTH_SEND_PASSWORD_RESET_EMAIL_URL:"http://localhost:8080/rest/VzwCareService/sendResetPasswordEmail",
		AUTH_RESET_PASSWORD_URL:"http://localhost:8080/rest/VzwCareService/resetvzwcareuserpassword",
		SEARCH_USER_REST_SERVICE_URL: "http://localhost:8080/rest/VzwAdminService/SearchUser",
		VIEW_USER_REST_SERVICE_URL: "http://localhost:8080/rest/VzwAdminService/GetUser",
		EDIT_USER_REST_SERVICE_URL: "http://localhost:8080/rest/VzwAdminService/AdminUpdateUser",
		CERATE_USER_REST_SERVICE_URL: "http://localhost:8080/rest/VzwAdminService/AdminRegistration"
};

SETTINGS={
		DEFAULT_VERSION: "1",
		DEFAULT_LANG: "en_US",
		CONTENT_TYPE: "application/json;charset=UTF-8",
		SUBMISSIONS_MIN_DATE:"03/28/2013"
};

function getNonNullValue (attVal) {
	if(attVal != null ) {
	   return attVal;
	} else {
	   return "";
	}
}
