//sort name ascending then id descending
function cmp(x, y){ // generic comparison function
	return x > y ? 1 : x < y ? -1 : 0; 
}

function replaceOverrideEcpdId(newId){     
 // var overrideEcpdIdIndex = document.getElementById("overrideECPDId_Index").value;      
  //document.getElementById("SubmissionVO_Attributes_LIST_" + overrideEcpdIdIndex + "_SubmissionAttributeVO_StringValue").value = newId;     
 // var overrideEcpdIdControl = document.getElementById("textField_SubmissionVO_Attributes_LIST_" + overrideEcpdIdIndex + "_SubmissionAttributeVO_StringValue");      
 // overrideEcpdIdControl.value = newId;      
  //Mark the page dirty so that Validation plugin will be triggered. if the line below is removed, the submission can be saved without comment but validation plugin will not be triggered.      
  //textAttributeModified(overrideEcpdIdControl);      
 // jQuery("#ecpdProfileHistoryDialog").dialog("close");      
  //Per discussion with Kimberly Stanton and Matt Hinz, CSRs would enter the comments before clicking save button. This will not be a one click change.       
  //The comment is required to be entered on this page since there is an existing validation that will prevent the saving of the page if the page has been marked dirty.       
  //document.getElementsByName("Save1")[0].click();     
}      
           


		   
function highlightPostValidationEcpdIds(){      
 
 	var postValidationEcpdId =  window.opener.document.getElementById("Postvalidation_ECPD_ID").innerHTML;
	if(postValidationEcpdId != null && postValidationEcpdId != "") {
	 jQuery(".ecpdProfileIdTd").each(function(index,obj){       
		if(obj.innerHTML == postValidationEcpdId){     
		jQuery(obj.parentNode).addClass("highlightedProfile");    
		}     
	 }); 
	}
	
     
 
}  

function toggleOlderProfiles(){      
   if(jQuery("#toggleOlderProfilesLink").html() == 'Show older profile batches'){      
		jQuery('#toggleOlderProfilesLink').html('Hide older profile batches');    
   } else {       
		jQuery('#toggleOlderProfilesLink').html('Show older profile batches');   
   }    
   jQuery('#olderProfileBatches').fadeToggle(300);   
}
function toggleFirstTableHiddenRows(){      
   if(jQuery('#firstTableExtraRowToggleLink').html() == 'Show all profiles in this batch'){   
	
		jQuery('#firstTableExtraRowToggleLink').html('Show only first 10 profiles in this batch');   
   }else{      
		
		jQuery('#firstTableExtraRowToggleLink').html('Show all profiles in this batch');  
   }       
   jQuery('.first-table-hidden-rows').toggle();     
} 

function RetrieveEcpdProfileHistoryRequest () {
	this.version="";
	this.lang="";
	this.synergyTrackingNo="";
}

function loadSubmissions(data) {
	jQuery("#tblECPDProfiles").show(); 
	jQuery("#tblECPDProfiles > tbody").empty();
	var t = "";
	var i=0;
	
	var ecpdProfiles = data.ecpdProfileDataSet;
	var firstTableDefaultRowCount = 10;
	var index = 1;
    var currRequestId;
	var firstTableStarted = false;
	var firstTableComplete = false;
	var linkOnFirstTableAdded = false;
	
	var hasOlderProfileBatches = false;
	var showFirstTableShowHideLink = false;

	var ecpdProfileHTML ="";
	
	jQuery.each(ecpdProfiles, function(i, record) {

		if(currRequestId == null || (currRequestId != null && currRequestId != getNonNullValue(record["requestId"]) )){
			currRequestId = getNonNullValue(record["requestId"]);
			index = 1;
		
			if(firstTableStarted && !firstTableComplete && showFirstTableShowHideLink){
				linkOnFirstTableAdded = true;

				ecpdProfileHTML = "<tr id='firstTableExtraRow' bgcolor='#dddddd'><td colspan='3' style='padding:2pt;'>" +
									"<a href='#' onClick='toggleFirstTableHiddenRows()'><span id='firstTableExtraRowToggleLink'>Show all profiles in this batch</span></a></td></tr>";
			}
		
			if(firstTableStarted){
				firstTableComplete = true;

				ecpdProfileHTML = ecpdProfileHTML + "</table>";
				if(!hasOlderProfileBatches){
					hasOlderProfileBatches = true;
					ecpdProfileHTML +="<br/>";
					ecpdProfileHTML += "<div class='graybox'>";
					ecpdProfileHTML += "<a href='#' onClick='toggleOlderProfiles()'><span id='toggleOlderProfilesLink'>Show older profile batches</span></a>" ;
					ecpdProfileHTML += "</div>";
					ecpdProfileHTML += "<div id='olderProfileBatches'>";
				}
			}
			ecpdProfileHTML += "<br/>";
			ecpdProfileHTML += "<div class='heading'>";
			if(!firstTableComplete){
			ecpdProfileHTML += "Latest ";
			}
			ecpdProfileHTML += "Profiles Retrieved " + getNonNullValue(record["requestId"]) +
			                   "</div>" +
			                   "<table border='0' cellspacing='1' cellpadding='1' width='100%'>" +
			                   "<tr bgcolor='#778899'>" +
			                   "<th><b>ECPD Profile Id</b></th>" +
			                   "<th><b>ECPD Profile Name</b></th>" +
			                   "<th><b>Base Score</b></th>" +
			                   "</tr>" ;

	    }
		
		if(index == (firstTableDefaultRowCount+1) && !firstTableComplete){
			showFirstTableShowHideLink = true;
		}
		
		
		var c="";
		if(index > firstTableDefaultRowCount && !firstTableComplete){
			c="class='first-table-hidden-rows'"; 
		}

        i= i+1;
	
	    if(i%2 == 0) {
		   bgcolor= "#eeeeee";
		} else {
			bgcolor= "#dddddd";
		}
		
		t = '<tr title="Click to use this profile to Override ECPD Id on the submission" bgcolor= \'' + bgcolor + '\' style="cursor: pointer;" ' +
			 getNonNullValue(record["ecpdProfileId"]) +'\')"  onmouseover="this.style.backgroundColor=\'#84A6B5\'" onmouseout="this.style.backgroundColor=\' ' +
			 bgcolor + '\'">' +
			 '<td class="ecpdProfileIdTd" >' + getNonNullValue(record["ecpdProfileId"]) + '</td>' +
			 '<td>'  + getNonNullValue(record["ecpdProfileName"]) + '</td>' +
			 '<td>' + getNonNullValue(record["baseScore"]) + '</td></tr>' ;
		
		ecpdProfileHTML += t;
		index++;
		firstTableStarted = true;
		

		
	});

	jQuery('#ecpdProfilesHeader').show();
	jQuery('#ecpdProfiles').html(ecpdProfileHTML);

	highlightPostValidationEcpdIds();

}

function clearResultsPanel() {
	jQuery("#tblECPDProfiles > tbody").empty();
	jQuery("#tblECPDProfiles").hide(); 

}

function handleRespOnSuccess( data, statusCode, xhr ) {
	
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		loadSubmissions(data);
		jQuery(window).scrollTop(0);
	} 
}

function showErrorMsg(message) {

	jQuery('#submissionDetailsErrorPanel').show();
	jQuery('#SubmissionDetailsResultPanel').hide();
	jQuery('#submissionDetailsErrorMsg').html(message);
}

function handleRespOnError( jqXHR, errorType, exception ) {

    var message = '<span style="font-weight:bold; color:#FF0000;">' + MESSAGES.ERROR.TECHNICAL_ERROR + '</span>';
	try {

		var data = JSON.parse(jqXHR.responseText);
		if(hasUserAuthenticated(jqXHR, false) == false  ) {
			message = '<span style="font-weight:bold; color:#FF0000;">' + MESSAGES.STATUS.USER_SESSION_EXPIRED + '</span>';
		} else if(hasUserAuthorized(jqXHR) == false  ) {
			message = '<span style="font-weight:bold; color:#FF0000;">' + 
			 MESSAGES.STATUS.RESOURCE_ACCESS_DENIED + '</span>';
		} else if(data.status != null && data.status == 'ERROR' && data.errorCode == 'NOT_FOUND') {
			message = '<span style="font-weight:bold; color:#FF0000;">No ECPD Profile History data found.</span>';
		}
	}catch(e) {
	    message = '<span style="font-weight:bold; color:#FF0000;">' + MESSAGES.ERROR.TECHNICAL_ERROR + '</span>';
	}
	jQuery('#ecpdProfilesHeader').hide();
	jQuery('#ecpdProfiles').html(message);
}

	
jQuery(document).ready(function() {
	

    
	if(checkUserSession(false) == false) {
		jQuery('#ecpdProfiles').html('<span style="font-weight:bold; color:#FF0000;">' + MESSAGES.STATUS.USER_SESSION_INVALID + '</span>');
		return false;
	}
	
        jQuery('#vzwTrackingNo').val(jQuery.trim(jQuery('#vzwTrackingNo').val()));
		jQuery('#mtn').val(jQuery.trim(jQuery('#mtn').val()));

			
		var ajaxRequest = {
			type: 'GET',
			url: URLS.RETRIEVE_ECPD_HISTORY_REST_SERVICE_URL, 
			data: '',
			async : true,
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,   
	        complete : function(){
				jQuery.unblockUI();
	        },
			error: handleRespOnError,
			success: handleRespOnSuccess
		};
		

		var postValidationEcpdId =  window.opener.document.getElementById("Postvalidation_ECPD_ID").innerHTML;
		postValidationEcpdId = (getNonNullValue(postValidationEcpdId) == "") ? 0 :  postValidationEcpdId;
		ajaxRequest.url =  ajaxRequest.url + "/1/en_US/" + GetURLParameter("synergyTrackingNo") + "/" + postValidationEcpdId;
		//Set Ajax Request Data
		var AjaxResult = jQuery.ajax(ajaxRequest);

		return false;

              


	
});