var seletedSearchTabId="SearchByMTN";

function SearchSubmissionsRequest () {
	this.version="";
	this.lang="";
	this.vzwTrackingNo="";
	this.mtn="";
	this.noofDays="";
	this.from_Date="";
	this.to_Date="";
	this.respFormat="";
}

function loadSubmissions(data) {


	jQuery("div#dt_example").show(); 
	jQuery("#searchResults > tbody").empty();
	$('#searchResults').dataTable().fnClearTable();
	var t = "";
	var i=0;
	jQuery.each(data.submissionDetails, function(i, submissionRecord) {
        i= i+1;
	
	    if(i%2 == 0) {
		   tblClass= 'gradeX';
		} else {
			tblClass= 'gradeC';
		}
	
	    var bfoEscalationFlag='N';
	    if(getNonNullValue(submissionRecord["BFO escalation"]) == 'true') {
			bfoEscalationFlag ='Y';
		}
		
		var bfoEscalationImage=' ';
		if(getNonNullValue(submissionRecord["BFO escalation"]) == 'true' &&  getNonNullValue(submissionRecord["BFO escalation complete date"]) == "") {
			bfoEscalationImage ='<img src = "images/BFOFlag.png" align="right" alt="BFO Escalation"/>';
		}
		
		
	
	     
	    t += '<tr class=">' + tblClass +'"><td><a href="page-viewsubmission.php?vzwTrackingNo='+ submissionRecord["VzW Tracking Number"] +  
		     '&submissionStatus=' + encodeURIComponent(getNonNullValue(submissionRecord["status"])) + 
		    '&rand=' + Math.random() + '">' + submissionRecord["VzW Tracking Number"] + '</a></td>'+ 
		 
		'<td>' + jQuery.datepicker.formatDate('mm/dd/yy', new Date(submissionRecord["Order Date Timestamp"]) ) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["Validation Start Date"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["status"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["Validation Status"]) + '</td> ' + 
		'<td>' + bfoEscalationFlag + '</td>' +
		'<td>' + bfoEscalationImage + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["MTN"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["firstName"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["lastName"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["VZW_BILLING_ZIP"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["email"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["Paystub Company Name"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["address1"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["Prevalidation ECPD ID"]) + '</td>' +
		'<td>' + getNonNullValue(submissionRecord["Postvalidation ECPD ID"]) + '</td>' ;
	

	});
	jQuery('#searchResults > tbody').append(t);
	jQuery('#searchResults').dataTable({
		"aaSorting" : [ [ 1, "asc" ] ],
		"bDestroy": true
 	});
}

function clearResultsPanel() {
	jQuery("#searchResults > tbody").empty();
	jQuery("div#dt_example").hide(); 
	removeTableResultsInStore();

}

function newSearch() {
	clearResultsPanel();
	jQuery("#formSearchSubm")[0].reset();
}



function showRetrieveSubmRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		loadSubmissions(data);
		jQuery(window).scrollTop(0);
		saveTableResultsInStore(data);
	} 
}

function handleRetrieveSubmRespOnError( jqXHR, errorType, exception ) {

    var message=MESSAGES.ERROR.TECHNICAL_ERROR;
	try
	{					
	
		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if (typeof (console) != 'undefined' && console != null) 
			{
				console.log("Error");
				console.log(data.status);
			}
			if(hasUserAuthenticated(jqXHR, false) == false  ) {
				message = MESSAGES.STATUS.USER_SESSION_EXPIRED;
			} else if(hasUserAuthorized(jqXHR) == false  ) {
				message = MESSAGES.STATUS.RESOURCE_ACCESS_DENIED;
			} else if(data.status != null && data.status == 'ERROR') {         	
				if(data.errorCode ==='CS_RESOURCE_NOT_FOUND')
				{
					message=MESSAGES.ERROR.SUBMISSION_SEARCH_NO_RECORDS_FOUND;
					if( data.errorDetails == 'No matching records found.') 
					{
						message=MESSAGES.ERROR.SUBMISSION_SEARCH_NO_MATCHING_RECORDS_FOUND;
					} else 
					{
						message=MESSAGES.ERROR.SUBMISSION_SEARCH_NO_RECORDS_FOUND;
					}
				}
				else if(data.errorCode ==='CS_REQUEST_VALIDATION_EXCEPTION')
				{
					message = MESSAGES.ERROR.VALIDATION_ERROR +"<br />" + data.errorDetails;
				} 
				 
			}
		}
	} 
	catch(e) 
	{
		console.log("Exception occured");
	}

	jQuery('#searchSubmResponse').show();	
	jQuery('#searchSubmResponse').html(message);

	return false;
}

function confirmBeforeRetrievingSubmissions() {

	try {
		var daysBetween = 0;
		if( jQuery('input:radio[name=searchfilter]:checked').val() == 'daysFilter' ) {
			searchsubmRequest.noofDays = jQuery('#days_select').val();
			daysBetween =  searchsubmRequest.noofDays;
		}else if( jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ) {
			searchsubmRequest.from_Date = jQuery('#from_dateSelect').val();
			searchsubmRequest.to_Date = jQuery('#to_dateSelect').val();
			daysBetween = (new Date(searchsubmRequest.to_Date) - new Date(searchsubmRequest.from_Date) )/1000/60/60/24;
		}
		
		 
	} catch(e) {
		console.log("Exception occured");
	}
	return true;
}
	
jQuery(document).ready(function() {

    checkUserSession(true);
	welcomeUser(); 

    
	jQuery('#vzwTrackingNo').bind("change keypress", function() {
		if (jQuery(this).val().length > 0) {
			jQuery('#mtn').val('');
		}
	});

	jQuery('#mtn').bind("change keypress", function() {
		if (jQuery(this).val().length > 0) {
			jQuery('#vzwTrackingNo').val('');
		}
	});
	
	jQuery('#days_select').click(function() { 
		jQuery("input[name=searchfilter][value=" + 'daysFilter' + "]").prop('checked', true);
	});
	
	jQuery('#from_dateSelect').click(function() { 
		jQuery( "#from_dateSelect" ).datepicker({
		    minDate:new Date(SETTINGS.SUBMISSIONS_MIN_DATE),   
		    maxDate:'+1D'
		});
		jQuery( "#from_dateSelect" ).datepicker( "show");
		jQuery("input[name=searchfilter][value=" + 'dateRangeFilter' + "]").prop('checked', true);
	});

	jQuery('#to_dateSelect').click(function() { 

		jQuery("#to_dateSelect").datepicker({
		    minDate:new Date(SETTINGS.SUBMISSIONS_MIN_DATE),  
		    maxDate:'+1D'
		});
		jQuery( "#to_dateSelect" ).datepicker( "show");
		jQuery("input[name=searchfilter][value=" + 'dateRangeFilter' + "]").prop('checked', true);
	});

    //Show previously selected Tab
    openSearchTab(seletedSearchTabId);
    
	jQuery('#btnSearch').click(function() {
		checkUserSession(true);
        jQuery('#vzwTrackingNo').val(jQuery.trim(jQuery('#vzwTrackingNo').val()));
		jQuery('#mtn').val(jQuery.trim(jQuery('#mtn').val()));
		clearResultsPanel();

			
		var ajaxRequest = {
			type: 'POST',
			url: URLS.SEARCH_SUBMISSIONS_REST_SERVICE_URL, 
			data: '{}',  
			datType: 'json',
			async : true, 
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,   
	        complete : function(){
				jQuery.unblockUI();
	        }, 
			error: handleRetrieveSubmRespOnError,
			success: showRetrieveSubmRespOnSuccess
		};
		
        var bValidationRes = false;

		if($("#SearchtabMenu dd").eq(0).is(".active") && (bValidationRes= validatorSeachByMTNSubmForm())) {
			// Tab1 selected. Search by MTN and Vzw Tracking number
			searchsubmRequest= new SearchSubmissionsRequest();
			searchsubmRequest.vzwTrackingNo=jQuery('#vzwTrackingNo').val();
			searchsubmRequest.mtn =jQuery('#mtn').val();
            searchsubmRequest.lang=SETTINGS.DEFAULT_LANG;
            searchsubmRequest.version=SETTINGS.DEFAULT_VERSION;  
            if( jQuery('input:radio[name=searchfilter]:checked').val() == 'daysFilter' ) {
                searchsubmRequest.noofDays = jQuery('#days_select').val();
            }else if( jQuery('input:radio[name=searchfilter]:checked').val() == 'dateRangeFilter' ) {
                searchsubmRequest.from_Date = jQuery('#from_dateSelect').val();
                searchsubmRequest.to_Date = jQuery('#to_dateSelect').val();
            }
            requstData=JSON.stringify(searchsubmRequest);
            
            //if selected date range is more than 90 days, show message that request can take longer time,
            var bconfirmation = confirmBeforeRetrievingSubmissions();
            if(!bconfirmation) {
               return false;
            }
        
		} 
        if ($("#SearchtabMenu dd").eq(1).is(".active") && (bValidationRes= validatorSeachByDemogSubmForm())) {

            ajaxRequest.url = URLS.SEARCH_SUBMISSIONS_BY_DEMOG_REST_SERVICE_URL;
            requstData = getSeachSubmissionsByDemogRequest();
            if(requstData == false) {
                bValidationRes = false;
            }
		} 
        if ($("#SearchtabMenu dd").eq(2).is(".active") && (bValidationRes= validatorSeachByCampAttrSubmForm())) {
            ajaxRequest.url = URLS.SEARCH_PAGINATED_SUBMISSIONS_BY_CAMPATTR_REST_SERVICE_URL;
            requstData = getPaginatedSubmissionsByCampAttrRequest();
            if(requstData == false) {
                bValidationRes = false;
            }
        } 

        if(! bValidationRes) {
            return false;
        }

        //Set Ajax Request Data
        ajaxRequest.data=requstData;
        var AjaxResult = jQuery.ajax(ajaxRequest);
            
		return false;
	});  
	
	jQuery('#searchResults').dataTable({
		"aaSorting" : [ [ 1, "asc" ] ],
		"bDestroy": true
 	});

	var tblResData =loadTableResultsFromStore();
	if(tblResData != null) {
		loadSubmissions(tblResData);
	}
			
}); 