function handleRespOnSuccess( data, statusCode, xhr ) {

	if(data.status == "SUCCESS"  ) {
		if(data.hasFiles) {
			jQuery('#paystubImage').show();
		}  
	} 
	
}
function handleRespOnError( jqXHR, errorType, exception ) {
	var message = MESSAGES.ERROR.TECHNICAL_ERROR;
	if(hasUserAuthenticated(jqXHR, false) == false  ) {
		message = MESSAGES.STATUS.USER_SESSION_EXPIRED;
	}
	if(hasUserAuthorized(jqXHR) == false  ) {
		message = MESSAGES.STATUS.RESOURCE_ACCESS_DENIED;
	}
}

function getHasImageAjaxRequest() {

	var ajaxRequest = {
		type: 'GET',
		url: URLS.PAY_STUB_HAS_IMAGE_REST_SERVICE_URL, 
		data: '',   
		async : true, 
		cache : false,
		contentType: SETTINGS.CONTENT_TYPE,   
		complete : function(){
			jQuery.unblockUI();
		}, 
		error: handleRespOnError,
		success: handleRespOnSuccess
	};

	return ajaxRequest;
	
}

function CheckSubmissionHasImage() {
	var request= getHasImageAjaxRequest();
	request.url =  request.url + "/1/en_US/" + jQuery('#trackingNumber').val();
	var AjaxResult = jQuery.ajax(request);
}


function openPaystubImage() {

	checkUserSession(true);
    var trackingNumber = jQuery('#trackingNumber').val();
	popUp(URLS.PAY_STUB_GET_IMAGE_REST_SERVICE_URL + '/1/en_US/'+ trackingNumber);
}