function popUp(URL) {
day = new Date();
id = day.getTime();
eval("page" + id + " = window.open(URL, '" + id + "', 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=0,width=570,height=775,left =270,top = 0');");
}


function createCookie(name, value, days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        var expires = "; expires=" + date.toGMTString();
    } else var expires = "";
    document.cookie = escape(name) + "=" + escape(value) + expires + "; path=/";
}

function readCookie(name) {
    var nameEQ = escape(name) + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) == 0) return unescape(c.substring(nameEQ.length, c.length));
    }
    return null;
}

function eraseCookie(name) {
    createCookie(name, "", -1);
}



function logout(reason) {
    clearSession();

	if (window.opener != null && !window.opener.closed) {
		window.opener.location="index.php?action=" + reason;
		window.close();
	}
	else {
		window.location="index.php?action=" + reason;
	}

}

function clearSession() {
	eraseCookie("X_AUTH");
	eraseCookie("cbfo_userName");
	eraseCookie("cbfo_firstName");
	eraseCookie("cbfo_userRoles");
	removeUserInfoInSessionStore();
	removeTableResultsInStore();
}

function hasUserAuthenticated(jqXHR, pageAutoRedirectFlag) {
	var bRes = false;
	if(jqXHR.status == 401) {
		bRes = false;
		//if(pageAutoRedirectFlag) {
			logout("sessionexpired");
		//} else {
		//	clearSession();
		//}
	} else {
		bRes = true;
	}
	return bRes;
}

function hasUserAuthorized(jqXHR) {
	var bRes = false;
	if(jqXHR.status == 403 ) {
		bRes = false;
	} else {
		bRes = true;
	}
	return bRes;
}

function isUserLoginSessionActive() {
    var bRes = false;
	var encodedToken = readCookie("X_AUTH");
	if( typeof encodedToken === 'undefined' || encodedToken === null || getNonNullValue(encodedToken) == "" ) {
		bRes = false;
	} else {
		bRes = true;
	}
	return bRes;
}

function gotoHomePage() {
	if(isUserhasRole('appcsr') || isUserhasRole('webuser')){
		//window.location = "SearchSubmissions/" +  "?rand=" + Math.random();
		window.location = "page-searchsubmissions.php";
	}
	else if(isUserhasRole('createuser') || isUserhasRole('updateuser')){
		window.location = "page-searchuser.php/" +  "?rand=" + Math.random();
	}
}


function checkUserSession(pageAutoRedirectFlag) {
	var bRes = false;

	var bfoUserdata =loadUserInfoFromSessionStore();

	if( getNonNullValue(getuserName()) == ""  ) {
		//if(pageAutoRedirectFlag) {
			logout("invalidsession");
		//}
	} else if(getNonNullValue(getuserName()) != "" && bfoUserdata == null) {
		copyExistingSession();
		bRes = true;
	} else if(getNonNullValue(getuserName()) != ""  &&  getuserName() != bfoUserdata.userName  ) {
		alert("Multiple user sessions are not allowed. Please login again.");
		logout("logout");
		return false;
	} else {
		bRes = true;
	}

	jQuery.ajaxSetup({
		beforeSend: function(xhr) {


			if(getNonNullValue(getuserName()) != "" && bfoUserdata != null && getuserName() != bfoUserdata.userName  ) {
				alert("Multiple user sessions are not allowed. Please login again.");
				logout("logout");
				return false;
			}

			jQuery.blockUI({message: MESSAGES.STATUS.AJAX_LOADING});
		}
	});


	return bRes;
}

function copyExistingSession() {

	var bfouser = { userName: getuserName() };
	saveUserInfoInSessionStore(bfouser);

}


function createSession(data) {

    clearSession();

	var bfouser = { userName: data.userVO.userName, userFName:data.userVO.consumerDemog.firstName,
					firstName:data.userVO.consumerDemog.firstName,
					lastName:data.userVO.consumerDemog.lastName,
					roles:data.userVO.roles,
					authToken: data.authToken };
	saveUserInfoInSessionStore(bfouser);
	var token="user:VERIZON:" + bfouser.userName + ":" +bfouser.authToken;
    var encodedToken = jQuery.base64.encode(token);
	createCookie("X_AUTH", encodedToken , 1);
	createCookie("cbfo_userName", bfouser.userName , 1);
	createCookie("cbfo_firstName", bfouser.firstName , 1);
	createCookie("cbfo_userRoles", bfouser.roles , 1);
}


function welcomeUser() {
	var strVal = readCookie("cbfo_firstName");
	var welcomeStr = "Hi, " + strVal + " | <a href='javascript:void(0)' id='linkChangePassword'>Change Password</a>";
	if(isUserhasRole('createuser') || isUserhasRole('updateuser')){
		welcomeStr += " | <a href='page-searchuser.php' id='linkChangePassword'>User Admin</a></span>";
	}
	jQuery('#SESSION_USER_firstName').html(welcomeStr);
}

function getuserName() {
	var strVal = readCookie("cbfo_userName");
	return strVal;
}

function getAuthHeaderPart(i){
	var strVal = readCookie("X_AUTH");
	var decodedToken = jQuery.base64.decode(strVal);
	return decodedToken.split(":")[i];
}

function getUserAuthToken() {
	return getAuthHeaderPart(3);
}

function getUserContext() {
	return getAuthHeaderPart(1);
}


function getuserRoles() {
	var strVal = readCookie("cbfo_userRoles");
	return strVal;
}

function isUserhasRole(role) {
	var strRoles = getuserRoles();
	var arrRoles;
	if(getNonNullValue(strRoles) != "") {
		arrRoles = strRoles.split(",");
		if(jQuery.inArray(role, arrRoles) >= 0) {
			return true;
		}
	}
	return false;
}

function saveUserInfoInSessionStore(data) {
	try {
		if(typeof(Storage)!=="undefined") {
			sessionStorage.setItem("bfouserinfo",JSON.stringify(data));
		}
	} catch(e) {
	}
}

function removeUserInfoInSessionStore() {
	try {
		if(typeof(Storage)!=="undefined") {
            if(sessionStorage.getItem("bfouserinfo") != null) {
	 			sessionStorage.removeItem('bfouserinfo');
			}
		}
	} catch(e) {
	}
}


function loadUserInfoFromSessionStore() {
    var data = null;
	try {
		if(typeof(Storage)!=="undefined") {
			data = JSON.parse(sessionStorage.getItem("bfouserinfo"));
		}
	} catch(e) {
	}
	return data;
}

function saveTableResultsInStore(data) {
	try {
		if(typeof(Storage)!=="undefined") {
			sessionStorage.setItem("tblsearchResultsData",JSON.stringify(data));
		}
	} catch(e) {
	}
}

function removeTableResultsInStore() {
	try {
		if(typeof(Storage)!=="undefined") {
            if(sessionStorage.getItem("tblsearchResultsData") != null) {
	 			sessionStorage.removeItem('tblsearchResultsData');
			}
		}
	} catch(e) {
	}
}


function loadTableResultsFromStore() {
    var data = null;
	try {
		if(typeof(Storage)!=="undefined") {
			data = JSON.parse(sessionStorage.getItem("tblsearchResultsData"));
		}
	} catch(e) {
	}
	return data;
}

function GetURLParameter(sParam)
{
    var sPageURL = window.location.search.substring(1);
    var sURLVariables = sPageURL.split('&');
    for (var i = 0; i < sURLVariables.length; i++)
    {
        var sParameterName = sURLVariables[i].split('=');
        if (sParameterName[0] == sParam)
        {
            return sParameterName[1];
        }
    }
}

function displayAdminNav()
{
	var nav;
	var sPageURL = window.location.pathname;
	if(isUserhasRole('createuser')){
		if(sPageURL.toLowerCase().indexOf('createuser') >= 0){
			nav = '<li class="active"><a href="page-createuser.php">Create User</a></li>';
		}
		else{
			nav = '<li><a href="page-createuser.php">Create User</a></li>';
		}
	}
	if(isUserhasRole('updateuser')){
		if(sPageURL.toLowerCase().indexOf('searchuser') >= 0 || sPageURL.toLowerCase().indexOf('viewuser')>=0){
			nav = nav+'<li class="active"><a href="page-searchuser.php">Search User</a></li>';
		}
		else{
			nav = nav+'<li><a href="page-searchuser.php">Search User</a></li>';
		}
	}
	if(isUserhasRole('appcsr') || isUserhasRole('webuser')){
		nav = nav+'<li><a href="javascript:gotoHomePage()">Search Submission</a></li>';
	}
	jQuery('#adminNavBar').html(nav);

}


jQuery(document).ready(function() {
	   // do stuff when DOM is ready
	 });
