function SearchSubmissionsRequest () {
	this.version="";
	this.lang="";
	this.vzwTrackingNo="";
	this.mtn="";
	this.noofDays="";
	this.from_Date="";
	this.to_Date="";
	this.respFormat="DetailedInfo";
}

Array.prototype.get = function(name) {
    for (var i=0, len=this.length; i<len; i++) {
        if (typeof this[i] != "object") continue;
        if (this[i].name === name) return this[i].value;
    }
};

function loadSubmissionDetails(record) {
	loadSubmissionAttributes(record)
	jQuery('#email').html(getNonNullValue(record["email"]));
	jQuery('#firstName').html(getNonNullValue(record["firstName"]));
	jQuery('#lastName').html(getNonNullValue(record["lastName"]));
	jQuery('#address1').html(getNonNullValue(record["address1"]));
	jQuery('#address2').html(getNonNullValue(record["address2"]));
	jQuery('#city').html(getNonNullValue(record["city"]));
	jQuery('#stateCode').html(getNonNullValue(record["stateCode"]));
	jQuery('#postalCode').html(getNonNullValue(record["postalCode"]));
	jQuery('#status').html(getNonNullValue(record["status"]));
	jQuery('#stateCode').html(getNonNullValue(record["stateCode"]));
	jQuery('#trackingNumber').val(getNonNullValue(record["trackingNumber"]));

	jQuery('#searchCriteria').html('Search results for: ' + getNonNullValue(record["firstName"]) + ' ' + getNonNullValue(record["lastName"]) + ', ' + getNonNullValue(record["postalCode"]));


}

function loadSubmissionAttributes(record) {

	var formPrintedSubmissionType = 'Upload';

	if(getNonNullValue(record.attributes.get("Form Printed Indicator")) == "true" || getNonNullValue(record.attributes.get("Form Printed Indicator")).toUpperCase() == "YES" ) {
		formPrintedSubmissionType = 'Mail in';
	}

	var Premium_Contract_Indicator_val = "No";
	if(getNonNullValue(record.attributes.get("Premium Contract Indicator")) == "true" || getNonNullValue(record.attributes.get("Premium Contract Indicator")).toUpperCase() == "YES"  ) {
		Premium_Contract_Indicator_val = "YES";
	}

	var Paystub_Required_Val = "No";
	if(getNonNullValue(record.attributes.get("Paystub Required")) == "true" || getNonNullValue(record.attributes.get("Paystub Required")).toUpperCase() == "YES") {
		Paystub_Required_Val = "YES";
	}


	jQuery('#VzW_Tracking_Number').html(getNonNullValue(record.attributes.get("VzW Tracking Number")));
	jQuery('#Order_Date_Timestamp').html(getNonNullValue(record.attributes.get("Order Date Timestamp")));
	jQuery('#MTN').html(getNonNullValue(record.attributes.get("MTN")));
	jQuery('#Account_Number').html(getNonNullValue(record.attributes.get("Account Number")));
	jQuery('#Customer_ID').html(getNonNullValue(record.attributes.get("Customer ID")));
	jQuery('#VZW_BILLING_ZIP').html(getNonNullValue(record.attributes.get("VZW_BILLING_ZIP")));
	jQuery('#Form_Printed_Indicator').html(formPrintedSubmissionType);
	jQuery('#Company_Name').html(getNonNullValue(record.attributes.get("Company Name")));
	jQuery('#Company_Address_1').html(getNonNullValue(record.attributes.get("Company Address 1")));
	jQuery('#Company_Address_2').html(getNonNullValue(record.attributes.get("Company Address 2")));
	jQuery('#Company_City').html(getNonNullValue(record.attributes.get("Company City")));
	jQuery('#Company_State').html(getNonNullValue(record.attributes.get("Company State")));
	jQuery('#Company_Zip').html(getNonNullValue(record.attributes.get("Company Zip")));
	jQuery('#Valid_Reason').html(getNonNullValue(record.attributes.get("Valid Reason")));
	jQuery('#Prevalidation_ECPD_ID').html(getNonNullValue(record.attributes.get("Prevalidation ECPD ID")));
	jQuery('#Postvalidation_ECPD_ID').html(getNonNullValue(record.attributes.get("Postvalidation ECPD ID")));
	jQuery('#BFO_escalation_complete_date').html(getNonNullValue(record.attributes.get("BFO escalation complete date")));


	jQuery('#Record_Received_Date').html(getNonNullValue(record.attributes.get("Order Date Timestamp")));
	jQuery('#Communication_Date').html(getNonNullValue(record.attributes.get("BFO escalation complete date")));

	if(record.customFieldsAPIInfo != null && record.customFieldsAPIInfo.status != null && record.customFieldsAPIInfo.status == "SUCCESS") {
		jQuery('#Keyed_Date').html(getNonNullValue(record.customFieldsAPIInfo.submissionKeyedDate));
		jQuery('#Status_Change_Date').html(getNonNullValue(record.customFieldsAPIInfo.lastStatusChangeDate));
	}

	jQuery('#Account_First_Name').html(getNonNullValue(record.attributes.get("Account First Name")));
	jQuery('#Account_Last_Name').html(getNonNullValue(record.attributes.get("Account Last Name")));

	jQuery('#Base_Plan_Discount').html(getNonNullValue(record.attributes.get("Base Plan Discount")));
	jQuery('#Standard_Plan_Discount').html(getNonNullValue(record.attributes.get("Standard Plan Discount")));
	jQuery('#Premium_Plan_Discount').html(getNonNullValue(record.attributes.get("Premium Plan Discount")));
	jQuery('#Premium_Contract_Indicator').html(Premium_Contract_Indicator_val);


	jQuery('#Paystub_Required').html(Paystub_Required_Val);
	jQuery('#Paystub_Date').html(getNonNullValue(record.attributes.get("Paystub Date")));

	jQuery('#Validation_Status').html(getNonNullValue(record.attributes.get("Validation Status")));
	jQuery('#Validation_Start_Date').html(getNonNullValue(record.attributes.get("Validation Start Date")));
	jQuery('#serviceName').html(getNonNullValue(record.attributes.get("serviceName")));
	jQuery('#lblPrevalidationECPDId').html("Prevalidation ECPD Profile ID: " + getNonNullValue(record.attributes.get("Prevalidation ECPD ID")));
	jQuery('#lblValidSectionUSWIN').html("USWIN: " + getNonNullValue(getuserName()));
	jQuery('#lblInvalidSectionUSWIN').html("USWIN: " + getNonNullValue(getuserName()));

	var bfoop=GetURLParameter('bfoop')
	var bfoV3Error = getNonNullValue(record.attributes.get("Verizon API error details"));
	var escelationCompleteDate = getNonNullValue(record.attributes.get("BFO escalation complete date"));

	var bfoValidationMsg ="";
	if(bfoop == 'VZW_BFO_VALIDATE') {
		jQuery( "#validateInvalidateAjaxRespSection" ).show();
		if(bfoV3Error == "") {
			bfoValidationMsg = "Successfully validated submission.";
		} else if(bfoV3Error != "" && escelationCompleteDate == ""){
			bfoValidationMsg ="Submission could not be validated.<br />Error: " + bfoV3Error;
		} else if (bfoV3Error != "" && escelationCompleteDate != "") {
			bfoValidationMsg = "Submission could not be validated but is marked off the queue.<br />Error: " + bfoV3Error;
		} else {
			bfoValidationMsg ="Submission could not be validated.<br />Unexpected error.";
		}
		jQuery( "#validateInvalidateAjaxResp" ).html(bfoValidationMsg);
	} else if(bfoop == 'VZW_BFO_INVALIDATE') {
		jQuery( "#validateInvalidateAjaxRespSection" ).show();
		bfoValidationMsg = "Successfully invalidated submission.";
 		jQuery( "#validateInvalidateAjaxResp" ).html(bfoValidationMsg);
	} else {

	}
}

function showRetrieveSubmRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		jQuery('#submissionDetailsErrorPanel').hide();
		jQuery('#SubmissionDetailsResultPanel').show();

		var subDetailsRecord;
		if(data.submissionDetails != null) {
			var vzwTrackingNo = getNonNullValue(GetURLParameter('vzwTrackingNo'));
			var submissionStatus = decodeURIComponent(getNonNullValue(GetURLParameter('submissionStatus')));
			//Find matching submission Record, If mutliple records have same confirmation number
			for (var i=0;i< data.submissionDetails.length;i++) {
			    var tmpSubRecord = data.submissionDetails[i];
				if(vzwTrackingNo === getNonNullValue(tmpSubRecord.attributes.get("VzW Tracking Number")) && submissionStatus === getNonNullValue(tmpSubRecord["status"])) {
					// Exact match found, exit loop
					subDetailsRecord = tmpSubRecord;
					break;
				} else if(subDetailsRecord  == null && vzwTrackingNo === getNonNullValue(tmpSubRecord.attributes.get("VzW Tracking Number")) ) {
					//Continue looping all records, for exact match. Otherwise this record
					subDetailsRecord = tmpSubRecord;
				} else {

				}

			}
			if(subDetailsRecord === 'undefined' || subDetailsRecord == null) {
				showErrorMsg("Submission details record is invalid.");
			}

		}

		loadSubmissionDetails(subDetailsRecord);
		CheckSubmissionHasImage();
		showValidateSection(subDetailsRecord);

		if(data.bfoInvalidReasons != null) {
			var InvalidReasonOptions="";
			for (var i=0;i<data.bfoInvalidReasons.length;i++)
			{
				InvalidReasonOptions = InvalidReasonOptions +  '<option value="'+ data.bfoInvalidReasons[i]  +'">' + data.bfoInvalidReasons[i] + '</option>' ;
			} 

			if(data.bfoInvalidReasons.length > 0) {
				jQuery('#selectInvalidreasons').html(InvalidReasonOptions);
			}
		}

		var validReasonOptions="";
		if(data.bfoValidReasons != null) {
			var InvalidReasonOptions="";
			for (var i=0;i<data.bfoValidReasons.length;i++)
			{
				validReasonOptions = validReasonOptions +  '<option value="'+ data.bfoValidReasons[i]  +'">' + data.bfoValidReasons[i] + '</option>' ;
			}
			if(data.bfoValidReasons.length > 0) {
				jQuery('#selectValidreasons').html(validReasonOptions);
			}
		}

	} else
	{
		showErrorMsg(MESSAGES.ERROR.TECHNICAL_ERROR);
	}
}

function openEcpdProfileHistory() {
  
	var trackingNumber = jQuery('#trackingNumber').val();
  	popUp("page-ecpdhistory.php?synergyTrackingNo="+ trackingNumber + "&rand=" + Math.random());


}

function showErrorMsg(message) {

	jQuery('#submissionDetailsErrorPanel').show();
	jQuery('#SubmissionDetailsResultPanel').hide();
	jQuery('#submissionDetailsErrorMsg').html(message);
}

function handleRetrieveSubmRespOnError( jqXHR, errorType, exception ) {

	var message = MESSAGES.ERROR.TECHNICAL_ERROR;
	if(hasUserAuthenticated(jqXHR, false) == false  ) {
		message = MESSAGES.STATUS.USER_SESSION_EXPIRED;
	} else if(hasUserAuthorized(jqXHR) == false  ) {
		message = MESSAGES.STATUS.RESOURCE_ACCESS_DENIED;
	}
	showErrorMsg(message);
}

function showValidateSection(record) {
	/*
		Ability to validate/invalidate ALL INVALID,PENDING FULFILLMENT,FULFILLMENT COMPLETE submissions.
		validate/invalidate section be visible for all invalids just not BFO escalated submissions.
	*/
	if( (record["status"].toLowerCase() == "invalid"
	     || record["status"].toLowerCase() == "pending fulfillment"
	     || record["status"].toLowerCase() == "fulfillment complete" ) && isUserhasRole("appcsr") ) {
		jQuery('#bfovalidationSection').show();
		jQuery('#bfoinvalidationSection').show();
	}
}


jQuery(document).ready(function() {

	checkUserSession(true);
	welcomeUser();

	jQuery.validator.addMethod("validEcpdId", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.ECPD_ID_REGEX.test(value);
    }, MESSAGES.ERROR.ECPD_ID_INVALID);


    jQuery.validator.addMethod("validMTN", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.MTN_REGEX.test(value);
    }, MESSAGES.ERROR.USERNAME_INVALID);

    jQuery.validator.addMethod("validTrackingNo", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.TRACKING_NO_REGEX.test(value);
    }, MESSAGES.ERROR.PASSWORD_INVALID);

	jQuery('#btnBFOValidate').click(function() {
	   processBFOValidation();
	   return false;
	});

	jQuery('#btnBFOInvalidate').click(function() {
	   processBFOInvalidation();
	   return false;
	});

	jQuery('#btnBFOSaveNotes').click(function() {
	   processSaveBFONotes();
	   return false;
	});

	jQuery('#chkDisableAPI').click(function() {
		   if(jQuery('#chkDisableAPI').is(':checked')){
			   var r=confirm("Click OK to continue updating the site status only, no changes will be made in billing.");
			   if (r == false) {
				   jQuery('#chkDisableAPI').attr("checked",false);
				   return false;
			   }
			   else
				return true;
			}
	});

 

		var ajaxRequest = {
			type: 'POST',
			url: URLS.SEARCH_SUBMISSIONS_REST_SERVICE_URL,
			data: '{}',  
			datType: 'json',
			async : true, 
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,
	        complete : function(){
				jQuery.unblockUI();
	        }, 
			error: handleRetrieveSubmRespOnError,
			success: showRetrieveSubmRespOnSuccess
		};
 
			retrieveSubmRequest= new SearchSubmissionsRequest();
			retrieveSubmRequest.vzwTrackingNo=GetURLParameter('vzwTrackingNo'); 
			retrieveSubmRequest.lang=SETTINGS.DEFAULT_LANG;
			retrieveSubmRequest.version=SETTINGS.DEFAULT_VERSION;

			//Set Ajax Request Data
			ajaxRequest.data=JSON.stringify(retrieveSubmRequest);
			var AjaxResult = jQuery.ajax(ajaxRequest);
          

	jQuery("#ecpdProfileHistoryDialog").dialog({
		 autoOpen: false,
		 closeOnEscape: true,
		 height: 600,
		 modal: true,
		 title: 'ECPD Profile History',
		 width: 600,
		 zIndex:3999,
		 resizable:true,
		 draggable:true,
		 open : function(){
			jQuery(".ui-dialog-titlebar-close").hide();
		 },
		 close: function(){
		 
		 },
		 overlay: { background: '#B6CBD3', opacity: '0.7'},
		 buttons: {
			Close: function(){
				$(this).dialog('close');
			}
		 }
	});
	return false;
 



}); 